VERSION 5.00
Begin VB.Form frmSwarm 
   BackColor       =   &H8000000A&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Particle Swarm Optimizer"
   ClientHeight    =   7350
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8460
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   Picture         =   "frmSwarm.frx":0000
   ScaleHeight     =   7350
   ScaleWidth      =   8460
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List_fun 
      Height          =   840
      ItemData        =   "frmSwarm.frx":0582
      Left            =   5280
      List            =   "frmSwarm.frx":0595
      TabIndex        =   26
      Top             =   1080
      Width           =   2895
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Left            =   6960
      Top             =   3480
   End
   Begin VB.TextBox OutFileText 
      Height          =   288
      Left            =   1200
      TabIndex        =   25
      Text            =   "psoutfil.txt"
      ToolTipText     =   "Output file name"
      Top             =   1080
      Width           =   2835
   End
   Begin VB.TextBox InertiaWText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   7320
      TabIndex        =   24
      Text            =   "0.9"
      ToolTipText     =   "Inertia weight"
      Top             =   600
      Width           =   800
   End
   Begin VB.TextBox MaxIterText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   5280
      TabIndex        =   23
      Text            =   "2000"
      ToolTipText     =   "Maximum number of generations"
      Top             =   600
      Width           =   800
   End
   Begin VB.TextBox MaxPText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   3240
      TabIndex        =   22
      Text            =   "100"
      ToolTipText     =   "Maximum position"
      Top             =   600
      Width           =   800
   End
   Begin VB.TextBox MaxVText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   1200
      TabIndex        =   21
      Text            =   "10"
      ToolTipText     =   "Maximum velocity"
      Top             =   600
      Width           =   800
   End
   Begin VB.TextBox MinErrorText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   7320
      TabIndex        =   20
      Text            =   "0.00001"
      ToolTipText     =   "Minimum error"
      Top             =   120
      Width           =   800
   End
   Begin VB.TextBox GloLocText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   5280
      TabIndex        =   19
      Text            =   "0"
      ToolTipText     =   "Global/Local"
      Top             =   120
      Width           =   800
   End
   Begin VB.TextBox DimensionText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   3240
      TabIndex        =   18
      Text            =   "2"
      ToolTipText     =   "Dimension of the problem space"
      Top             =   120
      Width           =   800
   End
   Begin VB.TextBox PopSizeText 
      Alignment       =   1  'Right Justify
      Height          =   288
      Left            =   1200
      TabIndex        =   17
      Text            =   "40"
      ToolTipText     =   "Number of Agents"
      Top             =   120
      Width           =   800
   End
   Begin VB.CommandButton cmdHelp 
      Caption         =   "About"
      CausesValidation=   0   'False
      Height          =   435
      Left            =   7080
      TabIndex        =   6
      Top             =   6720
      Width           =   1215
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      CausesValidation=   0   'False
      Height          =   435
      Left            =   5760
      TabIndex        =   5
      Top             =   6720
      Width           =   1215
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   435
      Left            =   4440
      TabIndex        =   4
      Top             =   6720
      Width           =   1215
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Pause"
      Enabled         =   0   'False
      Height          =   435
      Left            =   3000
      TabIndex        =   3
      Top             =   6720
      Width           =   1215
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Set Para."
      Height          =   435
      Left            =   240
      TabIndex        =   0
      Top             =   6720
      Width           =   1215
   End
   Begin VB.CommandButton cmdSwarm 
      Caption         =   "Run"
      Enabled         =   0   'False
      Height          =   435
      Left            =   1560
      TabIndex        =   1
      Top             =   6720
      Width           =   1335
   End
   Begin VB.PictureBox picSwarm1 
      DrawWidth       =   3
      Height          =   4695
      Left            =   120
      ScaleHeight     =   4635
      ScaleWidth      =   4995
      TabIndex        =   2
      ToolTipText     =   "Initialization"
      Top             =   1680
      Width           =   5055
   End
   Begin VB.Label Label_fun 
      BackColor       =   &H8000000E&
      Height          =   300
      Left            =   5760
      TabIndex        =   34
      Top             =   3120
      Width           =   2385
   End
   Begin VB.Label Label14 
      BackColor       =   &H8000000B&
      Caption         =   "Function Type:"
      Height          =   255
      Left            =   5520
      TabIndex        =   33
      Top             =   2760
      Width           =   1155
   End
   Begin VB.Label Label_bfit 
      BackColor       =   &H8000000E&
      Height          =   300
      Left            =   5745
      TabIndex        =   32
      Top             =   6000
      Width           =   2385
   End
   Begin VB.Label Label_binx 
      BackColor       =   &H8000000E&
      Height          =   300
      Left            =   5745
      TabIndex        =   31
      Top             =   5040
      Width           =   2385
   End
   Begin VB.Label Label_gen 
      BackColor       =   &H8000000E&
      Height          =   300
      Left            =   5745
      TabIndex        =   30
      Top             =   4080
      Width           =   2385
   End
   Begin VB.Label Label13 
      Caption         =   "Best Fitness:"
      Height          =   255
      Left            =   5520
      TabIndex        =   29
      Top             =   5640
      Width           =   1005
   End
   Begin VB.Label Label12 
      Caption         =   "Best Particle:"
      Height          =   255
      Left            =   5520
      TabIndex        =   28
      Top             =   4680
      Width           =   1005
   End
   Begin VB.Label Label10 
      BackColor       =   &H8000000B&
      Caption         =   "Generation:"
      Height          =   255
      Left            =   5520
      TabIndex        =   27
      Top             =   3720
      Width           =   1005
   End
   Begin VB.Label Label11 
      Caption         =   "Output File"
      Height          =   240
      Left            =   120
      TabIndex        =   16
      Top             =   1080
      Width           =   900
   End
   Begin VB.Label Label9 
      Caption         =   "Fun. Type"
      Height          =   240
      Left            =   4200
      TabIndex        =   15
      Top             =   1080
      Width           =   900
   End
   Begin VB.Label Label8 
      Caption         =   "Inertia Wei."
      Height          =   252
      Left            =   6240
      TabIndex        =   14
      Top             =   600
      Width           =   900
   End
   Begin VB.Label Label7 
      Caption         =   "Max. No. Iter"
      Height          =   240
      Left            =   4200
      TabIndex        =   13
      Top             =   600
      Width           =   900
   End
   Begin VB.Label Label6 
      Caption         =   "Max. Pos."
      Height          =   240
      Left            =   2160
      TabIndex        =   12
      Top             =   600
      Width           =   900
   End
   Begin VB.Label Label5 
      Caption         =   "Max. Vel."
      Height          =   240
      Left            =   120
      TabIndex        =   11
      Top             =   600
      Width           =   900
   End
   Begin VB.Label Label4 
      Caption         =   "Min Error"
      Height          =   240
      Left            =   6240
      TabIndex        =   10
      Top             =   120
      Width           =   900
   End
   Begin VB.Label Label3 
      Caption         =   "Glo/Loc"
      Height          =   240
      Left            =   4200
      TabIndex        =   9
      Top             =   120
      Width           =   900
   End
   Begin VB.Label Label2 
      Caption         =   "Dimension"
      Height          =   240
      Left            =   2160
      TabIndex        =   8
      Top             =   120
      Width           =   900
   End
   Begin VB.Label Label1 
      Caption         =   "                             Popu. Size"
      Height          =   400
      Left            =   1
      TabIndex        =   7
      Top             =   1
      Width           =   900
   End
End
Attribute VB_Name = "frmSwarm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Particle Swarm Optimizer, version 1.0, 01/04/2000
' Visual Basic 6.0
' graph iGbest, iLbest
' Sphere, Rosenbrock, Generalized Rastrigrin, Generalized Griewank functions

Option Explicit
Option Base 1
  Dim finishFlag As Integer
  Dim timerFlag As Integer
  Dim pauseFlag As Integer

  Dim iPOPSIZE As Integer       ' Population size
  Dim iDIMENSIONS As Integer    ' Number of dimensions
  Dim iPopindex As Integer      ' Index for population
  Dim iDimindex As Integer      ' Index for dimensions
  Dim fINITWT As Single         ' Initial inertia weight
  Dim fMAXVEL As Single         ' Maximum velocity allowed
  Dim nMAXITER As Integer       ' Maximum number of iterations
  Dim nIter As Integer          ' Number of iterations
  Dim fPos() As Single          ' Position for each particle
  Dim fTempPos() As Single      ' Temporary updated position for each particle
  Dim fVel() As Single          ' Velocity for each particle
  Dim fDumVel() As Single       ' Dummy velocity vector 1-dim array
  Dim fBestPos() As Single      ' Best previous position for each particle
  Dim fMaxPos As Single         ' Dynamic range
  Dim fInerWt As Single         ' Inertia weight
  Dim fErrVal() As Double       ' Function error value calculated by eval()
  Dim fPbestVal() As Double     ' Best error value over time for each particle
  Dim fERRCUTOFF As Double      ' Error value at which system stops
  'Dim iUSEBETTER As Integer     ' Usebetter is kind of a momentum
  Dim iBetter() As Integer      ' This gets set in program
  Dim iGbest As Integer         ' Index for global best particle
  Dim iLbest As Integer         ' Index for local (neighborhood) best particle
  Dim iLOCAL As Integer         ' Neighborhood size specified in run file
  Dim iHOODSIZE As Integer      ' Neighborhood size used in program
  Dim iHOODINDEX As Integer     ' Neighborhood index (offset from particle)
  Dim iNeighbor() As Integer    ' Popindexes of neighbors resulting from iLOCAL
  Dim sOutfile As String        ' Filename for output
  Dim iXcoord As Integer, iYcoord As Integer    ' x & y coords for plots
  Dim iFNCTNO As Integer        ' Function number to be optimized (1=f1, etc.)
  Dim fErrValDim As Double      ' Error value for a single dimension
  Const conPI = 3.14159265358979    ' Define Pi

Private Sub cmdExit_Click()
    End
End Sub

Private Sub cmdHelp_Click()
    MsgBox "Particle Swarm Optimizer Version 1.0, 01/04/2000", vbExclamation
End Sub

Private Sub cmdPause_Click()
    If pauseFlag = 0 Then
        timerFlag = 0
        Timer1.Enabled = False
        pauseFlag = 1
        cmdPause.Caption = "Continue..."
    Else
        timerFlag = 1
        pauseFlag = 0
        Timer1.Enabled = True
        cmdPause.Caption = "Pause"
        
    End If
    
    cmdStart.Enabled = False
    cmdSwarm.Enabled = False
    cmdPause.Enabled = True
    cmdStop.Enabled = True
    cmdExit.Enabled = False
    cmdHelp.Enabled = True
    
    PopSizeText.Enabled = False
    DimensionText.Enabled = False
    InertiaWText.Enabled = False
    MaxVText.Enabled = False
    MaxIterText.Enabled = False
    MaxPText.Enabled = False
    MinErrorText.Enabled = False
    GloLocText.Enabled = False
    OutFileText.Enabled = False
    List_fun.Enabled = False
    
End Sub

Private Sub cmdStart_Click()
    iPOPSIZE = CInt(PopSizeText.Text)
    iDIMENSIONS = CInt(DimensionText.Text)
    fINITWT = CSng(InertiaWText.Text)
    fMAXVEL = CSng(MaxVText.Text)
    nMAXITER = CInt(MaxIterText.Text)
    fMaxPos = CSng(MaxPText.Text)
    fERRCUTOFF = CDbl(MinErrorText.Text)
    iLOCAL = CInt(GloLocText.Text)
    sOutfile = CStr(OutFileText.Text)
    
    
    If iFNCTNO = -1 Then
        MsgBox "Please select a function!", vbExclamation
    Else
        
    finishFlag = 0
    pauseFlag = 0
    timerFlag = 1
    
    nIter = 1
     cmdSwarm.Enabled = True
     cmdStart.Enabled = False
     cmdStop.Enabled = True
     
     PopSizeText.Enabled = False
    DimensionText.Enabled = False
    InertiaWText.Enabled = False
    MaxVText.Enabled = False
    MaxIterText.Enabled = False
    MaxPText.Enabled = False
    MinErrorText.Enabled = False
    GloLocText.Enabled = False
    OutFileText.Enabled = False
    List_fun.Enabled = False
    End If
End Sub

Private Sub cmdStop_Click()
    finishFlag = 1
    timerFlag = 0
    Timer1.Enabled = False
    
    cmdStart.Enabled = True
    cmdSwarm.Enabled = False
    cmdPause.Enabled = False
    cmdStop.Enabled = True
    cmdExit.Enabled = True
    cmdHelp.Enabled = True
    
    PopSizeText.Enabled = True
    DimensionText.Enabled = True
    InertiaWText.Enabled = True
    MaxVText.Enabled = True
    MaxIterText.Enabled = True
    MaxPText.Enabled = True
    MinErrorText.Enabled = True
    GloLocText.Enabled = True
    OutFileText.Enabled = True
    List_fun.Enabled = True
End Sub

Private Sub cmdSwarm_Click()
  
  cmdStart.Enabled = False
  cmdSwarm.Enabled = False
  cmdPause.Enabled = True
  cmdStop.Enabled = True
  cmdExit.Enabled = False
  cmdHelp.Enabled = False
  
  PopSizeText.Enabled = False
    DimensionText.Enabled = False
    InertiaWText.Enabled = False
    MaxVText.Enabled = False
    MaxIterText.Enabled = False
    MaxPText.Enabled = False
    MinErrorText.Enabled = False
    GloLocText.Enabled = False
    OutFileText.Enabled = False
    List_fun.Enabled = False
    
  If iFNCTNO = 6 Or iFNCTNO = 5 Then iDIMENSIONS = 2  'Set # of dimensions for f5 & f6 fnctns

  ReDim fPos(iPOPSIZE, iDIMENSIONS)
  ReDim fTempPos(iPOPSIZE, iDIMENSIONS)
  ReDim fVel(iPOPSIZE, iDIMENSIONS)
  ReDim fBestPos(iPOPSIZE, iDIMENSIONS)
  ReDim fDumVel(iDIMENSIONS)
  ReDim fErrVal(iPOPSIZE)
  ReDim fPbestVal(iPOPSIZE)
  ReDim iBetter(iPOPSIZE)
  ReDim iNeighbor(-iPOPSIZE To iPOPSIZE)

    picSwarm1.BackColor = vbBlack

    If iLOCAL > 0 Then iHOODSIZE = Int(iLOCAL / 2#) * 2# Else iHOODSIZE = iPOPSIZE
        
    Randomize
    ' Randomize the positions and velocities for entire population
    For iPopindex = 1 To iPOPSIZE
        For iDimindex = 1 To iDIMENSIONS
            fPos(iPopindex, iDimindex) = Rnd * fMaxPos
            fBestPos(iPopindex, iDimindex) = fPos(iPopindex, iDimindex)
            fVel(iPopindex, iDimindex) = Rnd * fMAXVEL
            If Rnd > 0.5 Then fPos(iPopindex, iDimindex) = -fPos(iPopindex, iDimindex)
            If Rnd > 0.5 Then fVel(iPopindex, iDimindex) = -fVel(iPopindex, iDimindex)
            
        Next iDimindex
    Next iPopindex
                            
    Timer1.Enabled = True
    

End Sub

Sub oneg(nIter)
    
      ' Update inertia weight; linear from fINITWT to 0.4
        fInerWt = ((fINITWT - 0.4) * (nMAXITER - nIter) / nMAXITER) + 0.4
        
      For iPopindex = 1 To iPOPSIZE     'MAIN main loop starts here
            'Setup dummy velocity vector for current population member
            For iDimindex = 1 To iDIMENSIONS
                fDumVel(iDimindex) = fVel(iPopindex, iDimindex)
            Next iDimindex
            
            iBetter(iPopindex) = 0          ' Set to 0 unless new Pbest achieved
            
            Select Case iFNCTNO             ' returns fErrVal(iPopindex)
              Case 0
                Call evalf0(iPopindex)      ' evals f0 spherical function error
              Case 1
                Call evalf1(iPopindex)      ' evals f1 Rosenbrock function error
              Case 2
                Call evalf2(iPopindex)      ' evals f2 Rastrigrin function error
              Case 3
                Call evalf3(iPopindex)      ' evals f3 Griewank function error
              Case 5
                Call evalf5(iPopindex)      ' evals f5 He function error
              Case 6
                Call evalf6(iPopindex)      ' evals f6 Schaffer function error
            End Select
            
            
            If nIter = 1 Then
                fPbestVal(iPopindex) = fErrVal(iPopindex)
                iGbest = 1
            End If
            
            If fErrVal(iPopindex) < fPbestVal(iPopindex) Then   'If new Pbest
                fPbestVal(iPopindex) = fErrVal(iPopindex)
                
                For iDimindex = 1 To iDIMENSIONS    ' Reset Pbest location vector
                    fBestPos(iPopindex, iDimindex) = fPos(iPopindex, iDimindex)
                Next iDimindex
                
                If fPbestVal(iPopindex) < fPbestVal(iGbest) Then
                    ' color(iGbest) = DEFAULTCOLOR  need to dim these variables
                    iGbest = iPopindex
                    ' color(iGbest) = GBESTCOLOR
                End If
                
                
            End If                                     ' End new Pbest loop
      Next iPopindex            'end MAIN main loop for gold gbest only
      
      
      For iPopindex = 1 To iPOPSIZE         'update velocity, position, graph position
      
            ' Does neighborhood calculation of iLbest
            If iLOCAL > 0 Then
                For iHOODINDEX = 0 To iHOODSIZE
                    iNeighbor(iHOODINDEX) = iPopindex - (iHOODSIZE / 2#) + iHOODINDEX
                    
                    ' Now wrap the ends of the array
                    If iNeighbor(iHOODINDEX) < 1 Then iNeighbor(iHOODINDEX) = iPOPSIZE + _
                      iNeighbor(iHOODINDEX)
                    If iNeighbor(iHOODINDEX) > iPOPSIZE Then iNeighbor(iHOODINDEX) = _
                      iNeighbor(iHOODINDEX) - iPOPSIZE
                    'Start with iNeighbor(0) as iLbest and try to beat it
                    If iHOODINDEX = 0 Then iLbest = iNeighbor(0)
                    If fPbestVal(iNeighbor(iHOODINDEX)) < fPbestVal(iLbest) Then _
                      iLbest = iNeighbor(iHOODINDEX)
                Next iHOODINDEX
            End If
                        
            If iLOCAL = 0 Then iLbest = iGbest
                        
            ' Update velocity vector for one particle Russ Reduced version
            For iDimindex = 1 To iDIMENSIONS        'fInerWt below
                fVel(iPopindex, iDimindex) = (0.5 + (Rnd / 2)) * fVel(iPopindex, iDimindex) + _
                 2# * Rnd * (fBestPos(iPopindex, iDimindex) - fPos(iPopindex, iDimindex)) + _
                 2# * Rnd * (fBestPos(iLbest, iDimindex) - fPos(iPopindex, iDimindex))
                 
                If fVel(iPopindex, iDimindex) > fMAXVEL Then
                    fVel(iPopindex, iDimindex) = fMAXVEL
                ElseIf fVel(iPopindex, iDimindex) < -fMAXVEL Then
                    fVel(iPopindex, iDimindex) = -fMAXVEL
                End If
            Next iDimindex
            
            'If it's going the right way, keep going
            If iBetter(iPopindex) = 1 Then
                For iDimindex = 1 To iDIMENSIONS
                    fVel(iPopindex, iDimindex) = fDumVel(iDimindex)
                Next iDimindex
            End If
            
          ' Graphics Loop: Graphically plot updated positions
        
            'Erase old position for two dimensions of one particle
            iXcoord = Int((picSwarm1.ScaleWidth / 2#) * (1 + _
              10 * fPos(iPopindex, 1) / fMaxPos))
            iYcoord = Int((picSwarm1.ScaleHeight / 2#) * (1 + _
              10 * fPos(iPopindex, 2) / fMaxPos))
            picSwarm1.PSet (iXcoord, iYcoord), vbBlack
            
            For iDimindex = 1 To iDIMENSIONS  'Define new positions for all dimensions
                fPos(iPopindex, iDimindex) = fPos(iPopindex, iDimindex) + _
                  fVel(iPopindex, iDimindex)
            Next iDimindex
            
            'Graph new position for two dimensions of one particle
            iXcoord = Int((picSwarm1.ScaleWidth / 2#) * (1 + _
              10 * fPos(iPopindex, 1) / fMaxPos))
            iYcoord = Int((picSwarm1.ScaleHeight / 2#) * (1 + _
              10 * fPos(iPopindex, 2) / fMaxPos))
            picSwarm1.PSet (iXcoord, iYcoord), vbRed
            
            'If local neighborhood, graph iLbest
            If iLOCAL > 0 Then
             iXcoord = Int((picSwarm1.ScaleWidth / 2#) * (1 + _
              10 * fPos(iLbest, 1) / fMaxPos))
             iYcoord = Int((picSwarm1.ScaleHeight / 2#) * (1 + _
              10 * fPos(iLbest, 2) / fMaxPos))
             picSwarm1.PSet (iXcoord, iYcoord), vbYellow
            End If
            
      Next iPopindex                'end velocity, position, graph loop
        
        'Graph 2 dimensions of iGbest
            iXcoord = Int((picSwarm1.ScaleWidth / 2#) * (1 + _
              10 * fPos(iGbest, 1) / fMaxPos))
            iYcoord = Int((picSwarm1.ScaleHeight / 2#) * (1 + _
              10 * fPos(iGbest, 2) / fMaxPos))
            picSwarm1.PSet (iXcoord, iYcoord), vbWhite
        
        'Terminate on sufficiently low error
        If (fPbestVal(iGbest) < fERRCUTOFF) Or nIter >= nMAXITER Then
        '    MsgBox "Iter: " & nIter & "  Err: " & fPbestVal(iGbest) ', vbYesNo
            Open sOutfile For Append As #2       'psoutfile.txt
            Print #2, "Iter: " & nIter, " Best val: " & fPbestVal(iGbest), Now
            Print #2, "Neighd. size (0=global): " & iLOCAL, " Fnctn# " & iFNCTNO, _
              " #Dims " & iDIMENSIONS
            For iDimindex = 1 To iDIMENSIONS
                Print #2, "Dim. " & iDimindex, "Pos. " & fPos(iGbest, iDimindex)
            Next iDimindex
            Close #2
            finishFlag = 1
        '    End                     'END PROGRAM
        End If

    Label_gen.Caption = CStr(nIter)
    Label_bfit.Caption = CStr(fPbestVal(iGbest))
    Label_binx.Caption = CStr(iGbest)
    
End Sub
    Sub evalf6(iPopindex)             ' evaluates f6 function error: fVal(iPopindex)
        Dim fNum As Double, fDenom As Double, fF6val As Double
        
        fNum = (Sin(Sqr((fPos(iPopindex, 1) * fPos(iPopindex, 1) + _
            fPos(iPopindex, 2) * fPos(iPopindex, 2))))) ^ 2 - 0.5
        fDenom = (1# + 0.001 * (fPos(iPopindex, 1) * fPos(iPopindex, 1) + _
            fPos(iPopindex, 2) * fPos(iPopindex, 2))) ^ 2
        fF6val = 0.5 - (fNum / fDenom)
        fErrVal(iPopindex) = 1# - fF6val
    End Sub
    
    Sub evalf0(iPopindex)              'Evaluates spherical f0 function error
        fErrVal(iPopindex) = 0#
        
        For iDimindex = 1 To iDIMENSIONS
            fErrValDim = (fPos(iPopindex, iDimindex)) ^ 2
            fErrVal(iPopindex) = fErrVal(iPopindex) + fErrValDim
        Next iDimindex
        
    End Sub
    
    Sub evalf1(iPopindex)               ' Evaluates Rosenbrock f1 function error
        fErrVal(iPopindex) = 0#
        
        For iDimindex = 1 To iDIMENSIONS - 1
            fErrValDim = 100# * (fPos(iPopindex, iDimindex + 1) - (fPos(iPopindex, iDimindex)) ^ 2) ^ 2 + (fPos(iPopindex, iDimindex) - 1) ^ 2
            fErrVal(iPopindex) = fErrVal(iPopindex) + fErrValDim
        Next iDimindex
        
    End Sub

    Sub evalf2(iPopindex)               ' Evaluates Rastrigrin f2 function error
        fErrVal(iPopindex) = 0#
        
        For iDimindex = 1 To iDIMENSIONS
            fErrValDim = (fPos(iPopindex, iDimindex)) ^ 2 + 10# - 10# * Cos(2# * conPI * fPos(iPopindex, iDimindex))
            fErrVal(iPopindex) = fErrVal(iPopindex) + fErrValDim
        Next iDimindex
    End Sub

    Sub evalf3(iPopindex)       ' Evaluates Griewank f3 function error
        Dim fFirstDim As Double, fSecondDim As Double
        Dim fFirstTot As Double, fSecondTot As Double
        fErrVal(iPopindex) = 0#
        fFirstTot = 0#
        fSecondTot = 1#
    
        For iDimindex = 1 To iDIMENSIONS
            fFirstDim = (fPos(iPopindex, iDimindex)) ^ 2
            fFirstTot = fFirstTot + fFirstDim
            fSecondDim = Cos(fPos(iPopindex, iDimindex) / Sqr(iDimindex))
            fSecondTot = fSecondTot * fSecondDim
        Next iDimindex
        
        fErrVal(iPopindex) = (0.00025 * fFirstTot) - fSecondTot + 1#
    End Sub
    
    Sub evalf5(iPopindex)           'Evaluates He f5 function error
        fErrVal(iPopindex) = (fPos(iPopindex, 1)) ^ 2 + 2# * (fPos(iPopindex, 2)) ^ 2 - _
        0.3 * Cos(3# * conPI * fPos(iPopindex, 1)) - 0.4 * Cos(4# * conPI * fPos(iPopindex, 2)) + 0.7
    End Sub



Private Sub DimensionText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub DimensionText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If DimensionText.Text = "" Then
        MsgBox "Please enter positive number here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub Form_Load()
    Timer1.Interval = 50    ' timer event interval
    iFNCTNO = -1            ' default function
    
    frmSwarm.Show
End Sub


Private Sub GloLocText_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyUp
            GloLocText.Text = 1
        Case vbKeyDown
            GloLocText.Text = 0
        End Select
End Sub

Private Sub GloLocText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case 48 To 57   'This is a digit 0 or 1
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub GloLocText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If GloLocText.Text = "" Then
        MsgBox "Please enter either 0(global) or 1(local) here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub InertiaWText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case Is = 46    ' .
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub InertiaWText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If InertiaWText.Text = "" Then
        MsgBox "Please enter a numeric value here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub List_fun_Click()
    iFNCTNO = List_fun.ListIndex
    Select Case iFNCTNO             ' returns fErrVal(iPopindex)
              Case 0
                Label_fun.Caption = "Sphere"
              Case 1
                Label_fun.Caption = "Rosenbrock"
              Case 2
                Label_fun.Caption = "Generalized Rastrigrin"
              Case 3
                Label_fun.Caption = "Generalized Greiwank"
              Case 4
                iFNCTNO = 6
                Label_fun.Caption = "Shaffer F6"
                
    End Select
End Sub

Private Sub MaxIterText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub MaxIterText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If MaxIterText.Text = "" Then
        MsgBox "Please enter positive integer here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub MaxPText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case Is = 46    ' .
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub MaxPText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If MaxPText.Text = "" Then
        MsgBox "Please enter positive number here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub MaxVText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case Is = 46    ' .
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub MaxVText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If MaxVText.Text = "" Then
        MsgBox "Please enter positive integer here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub MinErrorText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case Is = 46    ' .
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select
End Sub

Private Sub MinErrorText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If MinErrorText.Text = "" Then
        MsgBox "Please enter a numeric value here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub OutFileText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If OutFileText.Text = "" Then
        MsgBox "Please enter a result file name here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub PopSizeText_KeyPress(KeyAscii As Integer)
    Select Case KeyAscii
        Case Is < 32    'Control keys are OK.
        Case 48 To 57   'This is a digit
        Case Else       'Reject any other key
            KeyAscii = 0
    End Select

End Sub

Private Sub PopSizeText_Validate(Cancel As Boolean)
    'Check that field is not empty
    If PopSizeText.Text = "" Then
        MsgBox "Please enter a positive integer here", vbExclamation
        Cancel = True
    End If
End Sub

Private Sub Timer1_Timer()
    Timer1.Enabled = False
    oneg (nIter)
    nIter = nIter + 1
    If finishFlag = 1 Then
        cmdStart.Enabled = True
        cmdSwarm.Enabled = False
        cmdPause.Enabled = False
        cmdStop.Enabled = False
        cmdExit.Enabled = True
        cmdHelp.Enabled = True
        
        PopSizeText.Enabled = True
        DimensionText.Enabled = True
        InertiaWText.Enabled = True
        MaxVText.Enabled = True
        MaxIterText.Enabled = True
        MaxPText.Enabled = True
        MinErrorText.Enabled = True
        GloLocText.Enabled = True
        OutFileText.Enabled = True
        List_fun.Enabled = True
            
        timerFlag = 0
    End If
    
    If timerFlag = 1 Then
        Timer1.Enabled = True
            
    End If
End Sub
